
// This file is generated by src/Tools/generateTemplates/templateClassPyExport.py out of the .XML file
// Every change you make here gets lost in the next full rebuild!
// This File is normally built as an include in CoordinateSystemPyImp.cpp! It's not intended to be in a project!

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Base/PyObjectBase.h>
#include <Base/Console.h>
#include <Base/Exception.h>
#include <CXX/Objects.hxx>

#if defined(__clang__)
# pragma clang diagnostic push
# pragma clang diagnostic ignored "-Wdeprecated-declarations"
#endif

using Base::streq;
using namespace Base;

#if defined(__GNUC__)
#pragma GCC diagnostic push
// Ignore -Wmissing-field-initializers (GCC only):
// - C++20 guarantees omitted fields are zero-initialized.
// - Python C API changes fields across versions.
// - Clang does not warn; GCC does unnecessarily.
// See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96868
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif // __GNUC__
/// Type structure of CoordinateSystemPy
PyTypeObject CoordinateSystemPy::Type = {
    .ob_base = PyVarObject_HEAD_INIT(&PyType_Type,0)
    .tp_name = "Base.CoordinateSystem",
    .tp_basicsize = sizeof(CoordinateSystemPy),
    .tp_itemsize = 0,
    /* methods */
    .tp_dealloc = PyDestructor,
    .tp_repr = __repr,
    .tp_getattro = __getattro,
    .tp_setattro = __setattro,
    /* --- Flags to define presence of optional/expanded features */
    .tp_flags = Py_TPFLAGS_BASETYPE|Py_TPFLAGS_DEFAULT,
    .tp_doc = "Base.CoordinateSystem class.\n"
    "\n"
    "An orthonormal right-handed coordinate system in 3D space.\n"
    "\n"
    "CoordinateSystem()\n"
    "Empty constructor.",
    .tp_methods = Base::CoordinateSystemPy::Methods,
    .tp_getset = Base::CoordinateSystemPy::GetterSetter,
    .tp_base = &Base::PyObjectBase::Type,
    .tp_init = __PyInit,
    .tp_new = Base::CoordinateSystemPy::PyMake
};
#if defined(__GNUC__)
#pragma GCC diagnostic pop
#endif // __GNUC__

/// Methods structure of CoordinateSystemPy
PyMethodDef CoordinateSystemPy::Methods[] = {
    {"setAxes",
        reinterpret_cast<PyCFunction>( staticCallback_setAxes ),
        METH_VARARGS,
        "setAxes(axis, xDir) -> None\n"
        "\n"
        "Set axis or Z-direction, and X-direction.\n"
        "The X-direction is determined from the orthonormal compononent of `xDir`\n"
        "with respect to `axis` direction.\n"
        "\n"
        "axis : Base.Axis, Base.Vector\n"
        "xDir : Base.Vector"
    },
    {"displacement",
        reinterpret_cast<PyCFunction>( staticCallback_displacement ),
        METH_VARARGS,
        "displacement(coordSystem2) -> Base.Placement\n"
        "\n"
        "Computes the placement from this to the passed coordinate system `coordSystem2`.\n"
        "\n"
        "coordSystem2 : Base.CoordinateSystem"
    },
    {"transformTo",
        reinterpret_cast<PyCFunction>( staticCallback_transformTo ),
        METH_VARARGS,
        "transformTo(vector) -> Base.Vector\n"
        "\n"
        "Computes the coordinates of the point in coordinates of this coordinate system.\n"
        "\n"
        "vector : Base.Vector"
    },
    {"transform",
        reinterpret_cast<PyCFunction>( staticCallback_transform ),
        METH_VARARGS,
        "transform(trans) -> None\n"
        "\n"
        "Applies a transformation on this coordinate system.\n"
        "\n"
        "trans : Base.Rotation, Base.Placement"
    },
    {"setPlacement",
        reinterpret_cast<PyCFunction>( staticCallback_setPlacement ),
        METH_VARARGS,
        "setPlacement(placement) -> None\n"
        "\n"
        "Set placement to the coordinate system.\n"
        "\n"
        "placement : Base.Placement"
    },
    {nullptr, nullptr, 0, nullptr}		/* Sentinel */
};



/// Attribute structure of CoordinateSystemPy
PyGetSetDef CoordinateSystemPy::GetterSetter[] = {
    {"Axis",
        (getter) staticCallback_getAxis,
        (setter) staticCallback_setAxis,
        "Set or get axis.",
        nullptr
    },
    {"XDirection",
        (getter) staticCallback_getXDirection,
        (setter) staticCallback_setXDirection,
        "Set or get X-direction.",
        nullptr
    },
    {"YDirection",
        (getter) staticCallback_getYDirection,
        (setter) staticCallback_setYDirection,
        "Set or get Y-direction.",
        nullptr
    },
    {"ZDirection",
        (getter) staticCallback_getZDirection,
        (setter) staticCallback_setZDirection,
        "Set or get Z-direction.",
        nullptr
    },
    {"Position",
        (getter) staticCallback_getPosition,
        (setter) staticCallback_setPosition,
        "Set or get position.",
        nullptr
    },
    {nullptr, nullptr, nullptr, nullptr, nullptr}		/* Sentinel */
};

// setAxes() callback and implementer
// PyObject*  CoordinateSystemPy::setAxes(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_setAxes (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setAxes' of 'Base.CoordinateSystem' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<CoordinateSystemPy*>(self)->setAxes(args);
        if (ret != nullptr)
            static_cast<CoordinateSystemPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// displacement() callback and implementer
// PyObject*  CoordinateSystemPy::displacement(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_displacement (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'displacement' of 'Base.CoordinateSystem' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }


    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<CoordinateSystemPy*>(self)->displacement(args);
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// transformTo() callback and implementer
// PyObject*  CoordinateSystemPy::transformTo(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_transformTo (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'transformTo' of 'Base.CoordinateSystem' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<CoordinateSystemPy*>(self)->transformTo(args);
        if (ret != nullptr)
            static_cast<CoordinateSystemPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// transform() callback and implementer
// PyObject*  CoordinateSystemPy::transform(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_transform (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'transform' of 'Base.CoordinateSystem' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<CoordinateSystemPy*>(self)->transform(args);
        if (ret != nullptr)
            static_cast<CoordinateSystemPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// setPlacement() callback and implementer
// PyObject*  CoordinateSystemPy::setPlacement(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_setPlacement (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setPlacement' of 'Base.CoordinateSystem' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<CoordinateSystemPy*>(self)->setPlacement(args);
        if (ret != nullptr)
            static_cast<CoordinateSystemPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// Axis() callback and implementer
// PyObject*  CoordinateSystemPy::Axis(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_getAxis (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<CoordinateSystemPy*>(self)->getAxis());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'Axis' of object 'CoordinateSystem'");
        return nullptr;
    }
}

int CoordinateSystemPy::staticCallback_setAxis (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<CoordinateSystemPy*>(self)->setAxis(Py::Object(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'Axis' of object 'CoordinateSystem'");
        return -1;
    }
}

// XDirection() callback and implementer
// PyObject*  CoordinateSystemPy::XDirection(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_getXDirection (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<CoordinateSystemPy*>(self)->getXDirection());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'XDirection' of object 'CoordinateSystem'");
        return nullptr;
    }
}

int CoordinateSystemPy::staticCallback_setXDirection (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<CoordinateSystemPy*>(self)->setXDirection(Py::Object(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'XDirection' of object 'CoordinateSystem'");
        return -1;
    }
}

// YDirection() callback and implementer
// PyObject*  CoordinateSystemPy::YDirection(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_getYDirection (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<CoordinateSystemPy*>(self)->getYDirection());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'YDirection' of object 'CoordinateSystem'");
        return nullptr;
    }
}

int CoordinateSystemPy::staticCallback_setYDirection (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<CoordinateSystemPy*>(self)->setYDirection(Py::Object(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'YDirection' of object 'CoordinateSystem'");
        return -1;
    }
}

// ZDirection() callback and implementer
// PyObject*  CoordinateSystemPy::ZDirection(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_getZDirection (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<CoordinateSystemPy*>(self)->getZDirection());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'ZDirection' of object 'CoordinateSystem'");
        return nullptr;
    }
}

int CoordinateSystemPy::staticCallback_setZDirection (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<CoordinateSystemPy*>(self)->setZDirection(Py::Object(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'ZDirection' of object 'CoordinateSystem'");
        return -1;
    }
}

// Position() callback and implementer
// PyObject*  CoordinateSystemPy::Position(PyObject *args){};
// has to be implemented in CoordinateSystemPyImp.cpp
PyObject * CoordinateSystemPy::staticCallback_getPosition (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<CoordinateSystemPy*>(self)->getPosition());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'Position' of object 'CoordinateSystem'");
        return nullptr;
    }
}

int CoordinateSystemPy::staticCallback_setPosition (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<CoordinateSystemPy*>(self)->setPosition(Py::Object(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'Position' of object 'CoordinateSystem'");
        return -1;
    }
}




//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------
CoordinateSystemPy::CoordinateSystemPy(CoordinateSystem *pcObject, PyTypeObject *T)
    : PyObjectBase(static_cast<PyObjectBase::PointerType>(pcObject), T)
{
}


//--------------------------------------------------------------------------
// destructor
//--------------------------------------------------------------------------
CoordinateSystemPy::~CoordinateSystemPy()                                // Everything handled in parent
{
    // delete the handled object when the PyObject dies
    CoordinateSystemPy::PointerType ptr = static_cast<CoordinateSystemPy::PointerType>(_pcTwinPointer);
    delete ptr;
}

//--------------------------------------------------------------------------
// CoordinateSystemPy representation
//--------------------------------------------------------------------------
PyObject *CoordinateSystemPy::_repr()
{
    return Py_BuildValue("s", representation().c_str());
}

//--------------------------------------------------------------------------
// CoordinateSystemPy Attributes
//--------------------------------------------------------------------------
PyObject *CoordinateSystemPy::_getattr(const char *attr)			// __getattr__ function: note only need to handle new state
{
    try {
        // getter method for special Attributes (e.g. dynamic ones)
        PyObject *r = getCustomAttributes(attr);
        if(r) return r;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError,"Unknown C++ exception");
        return nullptr;
    }
#endif

    PyMethodDef *ml = Methods;
    for (; ml->ml_name != nullptr; ml++) {
        if (attr[0] == ml->ml_name[0] &&
            strcmp(attr+1, ml->ml_name+1) == 0)
            return PyCFunction_New(ml, this);
    }

    PyErr_Clear();
    return PyObjectBase::_getattr(attr);
}

int CoordinateSystemPy::_setattr(const char *attr, PyObject *value) // __setattr__ function: note only need to handle new state
{
    try {
        // setter for special Attributes (e.g. dynamic ones)
        int r = setCustomAttributes(attr, value);
        // r = 1: handled
        // r = -1: error
        // r = 0: ignore
        if (r == 1)
            return 0;
        else if (r == -1)
            return -1;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return -1;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return -1;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return -1;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return -1;
    }
#endif

    return PyObjectBase::_setattr(attr, value);
}

CoordinateSystem *CoordinateSystemPy::getCoordinateSystemPtr() const
{
    return static_cast<CoordinateSystem *>(_pcTwinPointer);
}

#if defined(__clang__)
# pragma clang diagnostic pop
#endif

#if 0
/* From here on come the methods you have to implement, but NOT in this module. Implement in CoordinateSystemPyImp.cpp! This prototypes
 * are just for convenience when you add a new method.
 */

PyObject *CoordinateSystemPy::PyMake(PyTypeObject* /*type*/, PyObject* /*args*/, PyObject* /*kwds*/)
{
    // create a new instance of CoordinateSystemPy and the Twin object
    return new CoordinateSystemPy(new CoordinateSystem);
}

// constructor method
int CoordinateSystemPy::PyInit(PyObject* /*args*/, PyObject* /*kwd*/)
{
    return 0;
}


// returns a string which represents the object e.g. when printed in python
std::string CoordinateSystemPy::representation() const
{
    return {"<CoordinateSystem object>"};
}

PyObject* CoordinateSystemPy::setAxes(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* CoordinateSystemPy::displacement(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* CoordinateSystemPy::transformTo(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* CoordinateSystemPy::transform(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* CoordinateSystemPy::setPlacement(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}



Py::Object CoordinateSystemPy::getAxis() const
{
    //return Py::Object();
    throw Py::AttributeError("Not yet implemented");
}

void  CoordinateSystemPy::setAxis(Py::Object arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Object CoordinateSystemPy::getXDirection() const
{
    //return Py::Object();
    throw Py::AttributeError("Not yet implemented");
}

void  CoordinateSystemPy::setXDirection(Py::Object arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Object CoordinateSystemPy::getYDirection() const
{
    //return Py::Object();
    throw Py::AttributeError("Not yet implemented");
}

void  CoordinateSystemPy::setYDirection(Py::Object arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Object CoordinateSystemPy::getZDirection() const
{
    //return Py::Object();
    throw Py::AttributeError("Not yet implemented");
}

void  CoordinateSystemPy::setZDirection(Py::Object arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Object CoordinateSystemPy::getPosition() const
{
    //return Py::Object();
    throw Py::AttributeError("Not yet implemented");
}

void  CoordinateSystemPy::setPosition(Py::Object arg)
{
    throw Py::AttributeError("Not yet implemented");
}

PyObject *CoordinateSystemPy::getCustomAttributes(const char* /*attr*/) const
{
    return nullptr;
}

int CoordinateSystemPy::setCustomAttributes(const char* /*attr*/, PyObject* /*obj*/)
{
    return 0;
}


#endif



