
// This file is generated by src/Tools/generateTemplates/templateClassPyExport.py out of the .XML file
// Every change you make here gets lost in the next full rebuild!
// This File is normally built as an include in BRepOffsetAPI_MakeFillingPyImp.cpp! It's not intended to be in a project!

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Base/PyObjectBase.h>
#include <Base/Console.h>
#include <Base/Exception.h>
#include <CXX/Objects.hxx>

#if defined(__clang__)
# pragma clang diagnostic push
# pragma clang diagnostic ignored "-Wdeprecated-declarations"
#endif

using Base::streq;
using namespace Part;

#if defined(__GNUC__)
#pragma GCC diagnostic push
// Ignore -Wmissing-field-initializers (GCC only):
// - C++20 guarantees omitted fields are zero-initialized.
// - Python C API changes fields across versions.
// - Clang does not warn; GCC does unnecessarily.
// See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96868
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif // __GNUC__
/// Type structure of BRepOffsetAPI_MakeFillingPy
PyTypeObject BRepOffsetAPI_MakeFillingPy::Type = {
    .ob_base = PyVarObject_HEAD_INIT(&PyType_Type,0)
    .tp_name = "Part.BRepOffsetAPI_MakeFilling",
    .tp_basicsize = sizeof(BRepOffsetAPI_MakeFillingPy),
    .tp_itemsize = 0,
    /* methods */
    .tp_dealloc = PyDestructor,
    .tp_repr = __repr,
    .tp_getattro = __getattro,
    .tp_setattro = __setattro,
    /* --- Flags to define presence of optional/expanded features */
    .tp_flags = Py_TPFLAGS_BASETYPE|Py_TPFLAGS_DEFAULT,
    .tp_doc = "N-Side Filling",
    .tp_methods = Part::BRepOffsetAPI_MakeFillingPy::Methods,
    .tp_getset = Part::BRepOffsetAPI_MakeFillingPy::GetterSetter,
    .tp_base = &Base::PyObjectBase::Type,
    .tp_init = __PyInit,
    .tp_new = Part::BRepOffsetAPI_MakeFillingPy::PyMake
};
#if defined(__GNUC__)
#pragma GCC diagnostic pop
#endif // __GNUC__

/// Methods structure of BRepOffsetAPI_MakeFillingPy
PyMethodDef BRepOffsetAPI_MakeFillingPy::Methods[] = {
    {"setConstrParam",
        reinterpret_cast<PyCFunction>(reinterpret_cast<void (*) ()>( staticCallback_setConstrParam )),
        METH_VARARGS|METH_KEYWORDS,
        "setConstrParam(Tol2d=0.00001, Tol3d=0.0001, TolAng=0.01, TolCurv=0.1)\n"
        "Sets the values of Tolerances used to control the constraint."
    },
    {"setResolParam",
        reinterpret_cast<PyCFunction>(reinterpret_cast<void (*) ()>( staticCallback_setResolParam )),
        METH_VARARGS|METH_KEYWORDS,
        "setResolParam(Degree=3, NbPtsOnCur=15, NbIter=2, Anisotropy=False)\n"
        "Sets the parameters used for resolution."
    },
    {"setApproxParam",
        reinterpret_cast<PyCFunction>(reinterpret_cast<void (*) ()>( staticCallback_setApproxParam )),
        METH_VARARGS|METH_KEYWORDS,
        "setApproxParam(MaxDeg=8, MaxSegments=9)\n"
        "Sets the parameters used to approximate the filling the surface"
    },
    {"loadInitSurface",
        reinterpret_cast<PyCFunction>( staticCallback_loadInitSurface ),
        METH_VARARGS,
        "loadInitSurface(face)\n"
        "Loads the initial surface."
    },
    {"add",
        reinterpret_cast<PyCFunction>(reinterpret_cast<void (*) ()>( staticCallback_add )),
        METH_VARARGS|METH_KEYWORDS,
        "add(Edge, Order, IsBound=True)\n"
        "add(Edge, Support, Order, IsBound=True)\n"
        "add(Support, Order)\n"
        "add(Point)\n"
        "add(U, V, Support, Order)\n"
        "Adds a new constraint."
    },
    {"build",
        reinterpret_cast<PyCFunction>( staticCallback_build ),
        METH_VARARGS,
        "Builds the resulting faces."
    },
    {"isDone",
        reinterpret_cast<PyCFunction>( staticCallback_isDone ),
        METH_VARARGS,
        "Tests whether computation of the filling plate has been completed."
    },
    {"G0Error",
        reinterpret_cast<PyCFunction>( staticCallback_G0Error ),
        METH_VARARGS,
        "G0Error([int])\n"
        "Returns the maximum distance between the result and the constraints."
    },
    {"G1Error",
        reinterpret_cast<PyCFunction>( staticCallback_G1Error ),
        METH_VARARGS,
        "G1Error([int])\n"
        "Returns the maximum angle between the result and the constraints."
    },
    {"G2Error",
        reinterpret_cast<PyCFunction>( staticCallback_G2Error ),
        METH_VARARGS,
        "G2Error([int])\n"
        "Returns the greatest difference in curvature between the result and the constraints."
    },
    {"shape",
        reinterpret_cast<PyCFunction>( staticCallback_shape ),
        METH_VARARGS,
        "shape()\n"
        "Returns the resulting shape."
    },
    {nullptr, nullptr, 0, nullptr}		/* Sentinel */
};



/// Attribute structure of BRepOffsetAPI_MakeFillingPy
PyGetSetDef BRepOffsetAPI_MakeFillingPy::GetterSetter[] = {
    {nullptr, nullptr, nullptr, nullptr, nullptr}		/* Sentinel */
};

// setConstrParam() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::setConstrParam(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_setConstrParam (PyObject *self, PyObject *args, PyObject * kwd)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setConstrParam' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->setConstrParam(args, kwd);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// setResolParam() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::setResolParam(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_setResolParam (PyObject *self, PyObject *args, PyObject * kwd)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setResolParam' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->setResolParam(args, kwd);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// setApproxParam() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::setApproxParam(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_setApproxParam (PyObject *self, PyObject *args, PyObject * kwd)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setApproxParam' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->setApproxParam(args, kwd);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// loadInitSurface() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::loadInitSurface(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_loadInitSurface (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'loadInitSurface' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->loadInitSurface(args);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// add() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::add(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_add (PyObject *self, PyObject *args, PyObject * kwd)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'add' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->add(args, kwd);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// build() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::build(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_build (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'build' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->build(args);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// isDone() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::isDone(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_isDone (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'isDone' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->isDone(args);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// G0Error() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::G0Error(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_G0Error (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'G0Error' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->G0Error(args);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// G1Error() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::G1Error(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_G1Error (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'G1Error' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->G1Error(args);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// G2Error() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::G2Error(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_G2Error (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'G2Error' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->G2Error(args);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// shape() callback and implementer
// PyObject*  BRepOffsetAPI_MakeFillingPy::shape(PyObject *args){};
// has to be implemented in BRepOffsetAPI_MakeFillingPyImp.cpp
PyObject * BRepOffsetAPI_MakeFillingPy::staticCallback_shape (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'shape' of 'Part.BRepOffsetAPI_MakeFilling' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->shape(args);
        if (ret != nullptr)
            static_cast<BRepOffsetAPI_MakeFillingPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}




//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------
BRepOffsetAPI_MakeFillingPy::BRepOffsetAPI_MakeFillingPy(BRepOffsetAPI_MakeFilling *pcObject, PyTypeObject *T)
    : PyObjectBase(static_cast<PyObjectBase::PointerType>(pcObject), T)
{
}


//--------------------------------------------------------------------------
// destructor
//--------------------------------------------------------------------------
BRepOffsetAPI_MakeFillingPy::~BRepOffsetAPI_MakeFillingPy()                                // Everything handled in parent
{
    // delete the handled object when the PyObject dies
    BRepOffsetAPI_MakeFillingPy::PointerType ptr = static_cast<BRepOffsetAPI_MakeFillingPy::PointerType>(_pcTwinPointer);
    delete ptr;
}

//--------------------------------------------------------------------------
// BRepOffsetAPI_MakeFillingPy representation
//--------------------------------------------------------------------------
PyObject *BRepOffsetAPI_MakeFillingPy::_repr()
{
    return Py_BuildValue("s", representation().c_str());
}

//--------------------------------------------------------------------------
// BRepOffsetAPI_MakeFillingPy Attributes
//--------------------------------------------------------------------------
PyObject *BRepOffsetAPI_MakeFillingPy::_getattr(const char *attr)			// __getattr__ function: note only need to handle new state
{
    try {
        // getter method for special Attributes (e.g. dynamic ones)
        PyObject *r = getCustomAttributes(attr);
        if(r) return r;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError,"Unknown C++ exception");
        return nullptr;
    }
#endif

    PyMethodDef *ml = Methods;
    for (; ml->ml_name != nullptr; ml++) {
        if (attr[0] == ml->ml_name[0] &&
            strcmp(attr+1, ml->ml_name+1) == 0)
            return PyCFunction_New(ml, this);
    }

    PyErr_Clear();
    return PyObjectBase::_getattr(attr);
}

int BRepOffsetAPI_MakeFillingPy::_setattr(const char *attr, PyObject *value) // __setattr__ function: note only need to handle new state
{
    try {
        // setter for special Attributes (e.g. dynamic ones)
        int r = setCustomAttributes(attr, value);
        // r = 1: handled
        // r = -1: error
        // r = 0: ignore
        if (r == 1)
            return 0;
        else if (r == -1)
            return -1;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return -1;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return -1;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return -1;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return -1;
    }
#endif

    return PyObjectBase::_setattr(attr, value);
}

BRepOffsetAPI_MakeFilling *BRepOffsetAPI_MakeFillingPy::getBRepOffsetAPI_MakeFillingPtr() const
{
    return static_cast<BRepOffsetAPI_MakeFilling *>(_pcTwinPointer);
}

#if defined(__clang__)
# pragma clang diagnostic pop
#endif

#if 0
/* From here on come the methods you have to implement, but NOT in this module. Implement in BRepOffsetAPI_MakeFillingPyImp.cpp! This prototypes
 * are just for convenience when you add a new method.
 */

PyObject *BRepOffsetAPI_MakeFillingPy::PyMake(PyTypeObject* /*type*/, PyObject* /*args*/, PyObject* /*kwds*/)
{
    // create a new instance of BRepOffsetAPI_MakeFillingPy and the Twin object
    return new BRepOffsetAPI_MakeFillingPy(new BRepOffsetAPI_MakeFilling);
}

// constructor method
int BRepOffsetAPI_MakeFillingPy::PyInit(PyObject* /*args*/, PyObject* /*kwd*/)
{
    return 0;
}


// returns a string which represents the object e.g. when printed in python
std::string BRepOffsetAPI_MakeFillingPy::representation() const
{
    return {"<BRepOffsetAPI_MakeFilling object>"};
}

PyObject* BRepOffsetAPI_MakeFillingPy::setConstrParam(PyObject *args, PyObject *kwds)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::setResolParam(PyObject *args, PyObject *kwds)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::setApproxParam(PyObject *args, PyObject *kwds)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::loadInitSurface(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::add(PyObject *args, PyObject *kwds)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::build(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::isDone(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::G0Error(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::G1Error(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::G2Error(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* BRepOffsetAPI_MakeFillingPy::shape(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}



PyObject *BRepOffsetAPI_MakeFillingPy::getCustomAttributes(const char* /*attr*/) const
{
    return nullptr;
}

int BRepOffsetAPI_MakeFillingPy::setCustomAttributes(const char* /*attr*/, PyObject* /*obj*/)
{
    return 0;
}


#endif



