
// This file is generated by src/Tools/generateTemplates/templateClassPyExport.py out of the .XML file
// Every change you make here gets lost in the next full rebuild!
// This File is normally built as an include in Line2dSegmentPyImp.cpp! It's not intended to be in a project!

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Base/PyObjectBase.h>
#include <Base/Console.h>
#include <Base/Exception.h>
#include <CXX/Objects.hxx>

#if defined(__clang__)
# pragma clang diagnostic push
# pragma clang diagnostic ignored "-Wdeprecated-declarations"
#endif

using Base::streq;
using namespace Part;

#if defined(__GNUC__)
#pragma GCC diagnostic push
// Ignore -Wmissing-field-initializers (GCC only):
// - C++20 guarantees omitted fields are zero-initialized.
// - Python C API changes fields across versions.
// - Clang does not warn; GCC does unnecessarily.
// See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96868
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif // __GNUC__
/// Type structure of Line2dSegmentPy
PyTypeObject Line2dSegmentPy::Type = {
    .ob_base = PyVarObject_HEAD_INIT(&PyType_Type,0)
    .tp_name = "Part.Geom2d.Line2dSegment",
    .tp_basicsize = sizeof(Line2dSegmentPy),
    .tp_itemsize = 0,
    /* methods */
    .tp_dealloc = PyDestructor,
    .tp_repr = __repr,
    .tp_getattro = __getattro,
    .tp_setattro = __setattro,
    /* --- Flags to define presence of optional/expanded features */
    .tp_flags = Py_TPFLAGS_BASETYPE|Py_TPFLAGS_DEFAULT,
    .tp_doc = "Describes a line segment in 2D space.\n"
    "\n"
    "To create a line there are several ways:\n"
    "Part.Geom2d.Line2dSegment()\n"
    "    Creates a default line\n"
    "\n"
    "Part.Geom2d.Line2dSegment(Line)\n"
    "    Creates a copy of the given line\n"
    "\n"
    "Part.Geom2d.Line2dSegment(Point1,Point2)\n"
    "    Creates a line that goes through two given points.",
    .tp_methods = Part::Line2dSegmentPy::Methods,
    .tp_getset = Part::Line2dSegmentPy::GetterSetter,
    .tp_base = &Part::Curve2dPy::Type,
    .tp_init = __PyInit,
    .tp_new = Part::Line2dSegmentPy::PyMake
};
#if defined(__GNUC__)
#pragma GCC diagnostic pop
#endif // __GNUC__

/// Methods structure of Line2dSegmentPy
PyMethodDef Line2dSegmentPy::Methods[] = {
    {"setParameterRange",
        reinterpret_cast<PyCFunction>( staticCallback_setParameterRange ),
        METH_VARARGS,
        "Set the parameter range of the underlying line segment geometry."
    },
    {nullptr, nullptr, 0, nullptr}		/* Sentinel */
};



/// Attribute structure of Line2dSegmentPy
PyGetSetDef Line2dSegmentPy::GetterSetter[] = {
    {"StartPoint",
        (getter) staticCallback_getStartPoint,
        (setter) staticCallback_setStartPoint,
        "Returns the start point of this line segment.",
        nullptr
    },
    {"EndPoint",
        (getter) staticCallback_getEndPoint,
        (setter) staticCallback_setEndPoint,
        "Returns the end point of this line segment.",
        nullptr
    },
    {nullptr, nullptr, nullptr, nullptr, nullptr}		/* Sentinel */
};

// setParameterRange() callback and implementer
// PyObject*  Line2dSegmentPy::setParameterRange(PyObject *args){};
// has to be implemented in Line2dSegmentPyImp.cpp
PyObject * Line2dSegmentPy::staticCallback_setParameterRange (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setParameterRange' of 'Part.Geom2dLineSegment' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<Line2dSegmentPy*>(self)->setParameterRange(args);
        if (ret != nullptr)
            static_cast<Line2dSegmentPy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// StartPoint() callback and implementer
// PyObject*  Line2dSegmentPy::StartPoint(PyObject *args){};
// has to be implemented in Line2dSegmentPyImp.cpp
PyObject * Line2dSegmentPy::staticCallback_getStartPoint (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<Line2dSegmentPy*>(self)->getStartPoint());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'StartPoint' of object 'Geom2dLineSegment'");
        return nullptr;
    }
}

int Line2dSegmentPy::staticCallback_setStartPoint (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<Line2dSegmentPy*>(self)->setStartPoint(Py::Object(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'StartPoint' of object 'Geom2dLineSegment'");
        return -1;
    }
}

// EndPoint() callback and implementer
// PyObject*  Line2dSegmentPy::EndPoint(PyObject *args){};
// has to be implemented in Line2dSegmentPyImp.cpp
PyObject * Line2dSegmentPy::staticCallback_getEndPoint (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<Line2dSegmentPy*>(self)->getEndPoint());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'EndPoint' of object 'Geom2dLineSegment'");
        return nullptr;
    }
}

int Line2dSegmentPy::staticCallback_setEndPoint (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<Line2dSegmentPy*>(self)->setEndPoint(Py::Object(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'EndPoint' of object 'Geom2dLineSegment'");
        return -1;
    }
}




//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------
Line2dSegmentPy::Line2dSegmentPy(Geom2dLineSegment *pcObject, PyTypeObject *T)
    : Curve2dPy(static_cast<Curve2dPy::PointerType>(pcObject), T)
{
}


//--------------------------------------------------------------------------
// destructor
//--------------------------------------------------------------------------
Line2dSegmentPy::~Line2dSegmentPy()                                // Everything handled in parent
{
}

//--------------------------------------------------------------------------
// Line2dSegmentPy representation
//--------------------------------------------------------------------------
PyObject *Line2dSegmentPy::_repr()
{
    return Py_BuildValue("s", representation().c_str());
}

//--------------------------------------------------------------------------
// Line2dSegmentPy Attributes
//--------------------------------------------------------------------------
PyObject *Line2dSegmentPy::_getattr(const char *attr)			// __getattr__ function: note only need to handle new state
{
    try {
        // getter method for special Attributes (e.g. dynamic ones)
        PyObject *r = getCustomAttributes(attr);
        if(r) return r;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError,"Unknown C++ exception");
        return nullptr;
    }
#endif

    PyMethodDef *ml = Methods;
    for (; ml->ml_name != nullptr; ml++) {
        if (attr[0] == ml->ml_name[0] &&
            strcmp(attr+1, ml->ml_name+1) == 0)
            return PyCFunction_New(ml, this);
    }

    PyErr_Clear();
    return Curve2dPy::_getattr(attr);
}

int Line2dSegmentPy::_setattr(const char *attr, PyObject *value) // __setattr__ function: note only need to handle new state
{
    try {
        // setter for special Attributes (e.g. dynamic ones)
        int r = setCustomAttributes(attr, value);
        // r = 1: handled
        // r = -1: error
        // r = 0: ignore
        if (r == 1)
            return 0;
        else if (r == -1)
            return -1;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return -1;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return -1;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return -1;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return -1;
    }
#endif

    return Curve2dPy::_setattr(attr, value);
}

Geom2dLineSegment *Line2dSegmentPy::getGeom2dLineSegmentPtr() const
{
    return static_cast<Geom2dLineSegment *>(_pcTwinPointer);
}

#if defined(__clang__)
# pragma clang diagnostic pop
#endif

#if 0
/* From here on come the methods you have to implement, but NOT in this module. Implement in Line2dSegmentPyImp.cpp! This prototypes
 * are just for convenience when you add a new method.
 */

PyObject *Line2dSegmentPy::PyMake(PyTypeObject* /*type*/, PyObject* /*args*/, PyObject* /*kwds*/)
{
    // create a new instance of Line2dSegmentPy and the Twin object
    return new Line2dSegmentPy(new Geom2dLineSegment);
}

// constructor method
int Line2dSegmentPy::PyInit(PyObject* /*args*/, PyObject* /*kwd*/)
{
    return 0;
}


// returns a string which represents the object e.g. when printed in python
std::string Line2dSegmentPy::representation() const
{
    return {"<Geom2dLineSegment object>"};
}

PyObject* Line2dSegmentPy::setParameterRange(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}



Py::Object Line2dSegmentPy::getStartPoint() const
{
    //return Py::Object();
    throw Py::AttributeError("Not yet implemented");
}

void  Line2dSegmentPy::setStartPoint(Py::Object arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Object Line2dSegmentPy::getEndPoint() const
{
    //return Py::Object();
    throw Py::AttributeError("Not yet implemented");
}

void  Line2dSegmentPy::setEndPoint(Py::Object arg)
{
    throw Py::AttributeError("Not yet implemented");
}

PyObject *Line2dSegmentPy::getCustomAttributes(const char* /*attr*/) const
{
    return nullptr;
}

int Line2dSegmentPy::setCustomAttributes(const char* /*attr*/, PyObject* /*obj*/)
{
    return 0;
}


#endif



