
// This file is generated by src/Tools/generateTemplates/templateClassPyExport.py out of the .XML file
// Every change you make here gets lost in the next full rebuild!
// This File is normally built as an include in ExternalGeometryFacadePyImp.cpp! It's not intended to be in a project!

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Base/PyObjectBase.h>
#include <Base/Console.h>
#include <Base/Exception.h>
#include <CXX/Objects.hxx>

#if defined(__clang__)
# pragma clang diagnostic push
# pragma clang diagnostic ignored "-Wdeprecated-declarations"
#endif

using Base::streq;
using namespace Sketcher;

#if defined(__GNUC__)
#pragma GCC diagnostic push
// Ignore -Wmissing-field-initializers (GCC only):
// - C++20 guarantees omitted fields are zero-initialized.
// - Python C API changes fields across versions.
// - Clang does not warn; GCC does unnecessarily.
// See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96868
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif // __GNUC__
/// Type structure of ExternalGeometryFacadePy
PyTypeObject ExternalGeometryFacadePy::Type = {
    .ob_base = PyVarObject_HEAD_INIT(&PyType_Type,0)
    .tp_name = "Sketcher.ExternalGeometryFacade",
    .tp_basicsize = sizeof(ExternalGeometryFacadePy),
    .tp_itemsize = 0,
    /* methods */
    .tp_dealloc = PyDestructor,
    .tp_repr = __repr,
    .tp_getattro = __getattro,
    .tp_setattro = __setattro,
    /* --- Flags to define presence of optional/expanded features */
    .tp_flags = Py_TPFLAGS_BASETYPE|Py_TPFLAGS_DEFAULT,
    .tp_doc = "Describes a GeometryFacade",
    .tp_methods = Sketcher::ExternalGeometryFacadePy::Methods,
    .tp_getset = Sketcher::ExternalGeometryFacadePy::GetterSetter,
    .tp_base = &Base::BaseClassPy::Type,
    .tp_init = __PyInit,
    .tp_new = Sketcher::ExternalGeometryFacadePy::PyMake
};
#if defined(__GNUC__)
#pragma GCC diagnostic pop
#endif // __GNUC__

/// Methods structure of ExternalGeometryFacadePy
PyMethodDef ExternalGeometryFacadePy::Methods[] = {
    {"testFlag",
        reinterpret_cast<PyCFunction>( staticCallback_testFlag ),
        METH_VARARGS,
        "Returns a boolean indicating whether the given bit is set."
    },
    {"setFlag",
        reinterpret_cast<PyCFunction>( staticCallback_setFlag ),
        METH_VARARGS,
        "Sets the given bit to true/false."
    },
    {"mirror",
        reinterpret_cast<PyCFunction>( staticCallback_mirror ),
        METH_VARARGS,
        "Performs the symmetrical transformation of this geometric object"
    },
    {"rotate",
        reinterpret_cast<PyCFunction>( staticCallback_rotate ),
        METH_VARARGS,
        "Rotates this geometric object at angle Ang (in radians) about axis"
    },
    {"scale",
        reinterpret_cast<PyCFunction>( staticCallback_scale ),
        METH_VARARGS,
        "Applies a scaling transformation on this geometric object with a center and scaling factor"
    },
    {"transform",
        reinterpret_cast<PyCFunction>( staticCallback_transform ),
        METH_VARARGS,
        "Applies a transformation to this geometric object"
    },
    {"translate",
        reinterpret_cast<PyCFunction>( staticCallback_translate ),
        METH_VARARGS,
        "Translates this geometric object"
    },
    {"hasExtensionOfType",
        reinterpret_cast<PyCFunction>( staticCallback_hasExtensionOfType ),
        METH_VARARGS,
        "Returns a boolean indicating whether a geometry extension of the type indicated as a string exists."
    },
    {"hasExtensionOfName",
        reinterpret_cast<PyCFunction>( staticCallback_hasExtensionOfName ),
        METH_VARARGS,
        "Returns a boolean indicating whether a geometry extension with the name indicated as a string exists."
    },
    {"getExtensionOfType",
        reinterpret_cast<PyCFunction>( staticCallback_getExtensionOfType ),
        METH_VARARGS,
        "Gets the first geometry extension of the type indicated by the string."
    },
    {"getExtensionOfName",
        reinterpret_cast<PyCFunction>( staticCallback_getExtensionOfName ),
        METH_VARARGS,
        "Gets the first geometry extension of the name indicated by the string."
    },
    {"setExtension",
        reinterpret_cast<PyCFunction>( staticCallback_setExtension ),
        METH_VARARGS,
        "Sets a geometry extension of the indicated type."
    },
    {"deleteExtensionOfType",
        reinterpret_cast<PyCFunction>( staticCallback_deleteExtensionOfType ),
        METH_VARARGS,
        "Deletes all extensions of the indicated type."
    },
    {"deleteExtensionOfName",
        reinterpret_cast<PyCFunction>( staticCallback_deleteExtensionOfName ),
        METH_VARARGS,
        "Deletes all extensions of the indicated name."
    },
    {"getExtensions",
        reinterpret_cast<PyCFunction>( staticCallback_getExtensions ),
        METH_VARARGS,
        "Returns a list with information about the geometry extensions."
    },
    {nullptr, nullptr, 0, nullptr}		/* Sentinel */
};



/// Attribute structure of ExternalGeometryFacadePy
PyGetSetDef ExternalGeometryFacadePy::GetterSetter[] = {
    {"Ref",
        (getter) staticCallback_getRef,
        (setter) staticCallback_setRef,
        "Returns the reference string of this external geometry.",
        nullptr
    },
    {"Id",
        (getter) staticCallback_getId,
        (setter) staticCallback_setId,
        "Sets/returns the Internal Alignment Type of the Geometry.",
        nullptr
    },
    {"Construction",
        (getter) staticCallback_getConstruction,
        (setter) staticCallback_setConstruction,
        "Sets/returns this geometry as a construction one, which will not be part of a later built shape.",
        nullptr
    },
    {"GeometryLayerId",
        (getter) staticCallback_getGeometryLayerId,
        (setter) staticCallback_setGeometryLayerId,
        "Returns the Id of the geometry Layer in which the geometry is located.",
        nullptr
    },
    {"InternalType",
        (getter) staticCallback_getInternalType,
        (setter) staticCallback_setInternalType,
        "Sets/returns the Internal Alignment Type of the Geometry.",
        nullptr
    },
    {"Blocked",
        (getter) staticCallback_getBlocked,
        (setter) staticCallback_setBlocked,
        "Sets/returns whether the geometry is blocked or not.",
        nullptr
    },
    {"Tag",
        (getter) staticCallback_getTag,
        (setter) staticCallback_setTag,
        "Gives the tag of the geometry as string.",
        nullptr
    },
    {"Geometry",
        (getter) staticCallback_getGeometry,
        (setter) staticCallback_setGeometry,
        "Returns the underlying geometry object.",
        nullptr
    },
    {nullptr, nullptr, nullptr, nullptr, nullptr}		/* Sentinel */
};

// testFlag() callback and implementer
// PyObject*  ExternalGeometryFacadePy::testFlag(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_testFlag (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'testFlag' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }


    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->testFlag(args);
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// setFlag() callback and implementer
// PyObject*  ExternalGeometryFacadePy::setFlag(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_setFlag (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setFlag' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->setFlag(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// mirror() callback and implementer
// PyObject*  ExternalGeometryFacadePy::mirror(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_mirror (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'mirror' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->mirror(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// rotate() callback and implementer
// PyObject*  ExternalGeometryFacadePy::rotate(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_rotate (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'rotate' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->rotate(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// scale() callback and implementer
// PyObject*  ExternalGeometryFacadePy::scale(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_scale (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'scale' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->scale(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// transform() callback and implementer
// PyObject*  ExternalGeometryFacadePy::transform(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_transform (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'transform' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->transform(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// translate() callback and implementer
// PyObject*  ExternalGeometryFacadePy::translate(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_translate (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'translate' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->translate(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// hasExtensionOfType() callback and implementer
// PyObject*  ExternalGeometryFacadePy::hasExtensionOfType(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_hasExtensionOfType (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'hasExtensionOfType' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }


    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->hasExtensionOfType(args);
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// hasExtensionOfName() callback and implementer
// PyObject*  ExternalGeometryFacadePy::hasExtensionOfName(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_hasExtensionOfName (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'hasExtensionOfName' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }


    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->hasExtensionOfName(args);
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// getExtensionOfType() callback and implementer
// PyObject*  ExternalGeometryFacadePy::getExtensionOfType(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getExtensionOfType (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'getExtensionOfType' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }


    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->getExtensionOfType(args);
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// getExtensionOfName() callback and implementer
// PyObject*  ExternalGeometryFacadePy::getExtensionOfName(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getExtensionOfName (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'getExtensionOfName' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }


    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->getExtensionOfName(args);
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// setExtension() callback and implementer
// PyObject*  ExternalGeometryFacadePy::setExtension(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_setExtension (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'setExtension' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->setExtension(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// deleteExtensionOfType() callback and implementer
// PyObject*  ExternalGeometryFacadePy::deleteExtensionOfType(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_deleteExtensionOfType (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'deleteExtensionOfType' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->deleteExtensionOfType(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// deleteExtensionOfName() callback and implementer
// PyObject*  ExternalGeometryFacadePy::deleteExtensionOfName(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_deleteExtensionOfName (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'deleteExtensionOfName' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->deleteExtensionOfName(args);
        if (ret != nullptr)
            static_cast<ExternalGeometryFacadePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// getExtensions() callback and implementer
// PyObject*  ExternalGeometryFacadePy::getExtensions(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getExtensions (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'getExtensions' of 'Sketcher.ExternalGeometryFacade' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }


    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<ExternalGeometryFacadePy*>(self)->getExtensions(args);
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// Ref() callback and implementer
// PyObject*  ExternalGeometryFacadePy::Ref(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getRef (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<ExternalGeometryFacadePy*>(self)->getRef());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'Ref' of object 'ExternalGeometryFacade'");
        return nullptr;
    }
}

int ExternalGeometryFacadePy::staticCallback_setRef (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<ExternalGeometryFacadePy*>(self)->setRef(Py::String(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'Ref' of object 'ExternalGeometryFacade'");
        return -1;
    }
}

// Id() callback and implementer
// PyObject*  ExternalGeometryFacadePy::Id(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getId (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<ExternalGeometryFacadePy*>(self)->getId());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'Id' of object 'ExternalGeometryFacade'");
        return nullptr;
    }
}

int ExternalGeometryFacadePy::staticCallback_setId (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<ExternalGeometryFacadePy*>(self)->setId(Py::Long(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'Id' of object 'ExternalGeometryFacade'");
        return -1;
    }
}

// Construction() callback and implementer
// PyObject*  ExternalGeometryFacadePy::Construction(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getConstruction (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<ExternalGeometryFacadePy*>(self)->getConstruction());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'Construction' of object 'ExternalGeometryFacade'");
        return nullptr;
    }
}

int ExternalGeometryFacadePy::staticCallback_setConstruction (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<ExternalGeometryFacadePy*>(self)->setConstruction(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'Construction' of object 'ExternalGeometryFacade'");
        return -1;
    }
}

// GeometryLayerId() callback and implementer
// PyObject*  ExternalGeometryFacadePy::GeometryLayerId(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getGeometryLayerId (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<ExternalGeometryFacadePy*>(self)->getGeometryLayerId());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'GeometryLayerId' of object 'ExternalGeometryFacade'");
        return nullptr;
    }
}

int ExternalGeometryFacadePy::staticCallback_setGeometryLayerId (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<ExternalGeometryFacadePy*>(self)->setGeometryLayerId(Py::Long(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'GeometryLayerId' of object 'ExternalGeometryFacade'");
        return -1;
    }
}

// InternalType() callback and implementer
// PyObject*  ExternalGeometryFacadePy::InternalType(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getInternalType (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<ExternalGeometryFacadePy*>(self)->getInternalType());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'InternalType' of object 'ExternalGeometryFacade'");
        return nullptr;
    }
}

int ExternalGeometryFacadePy::staticCallback_setInternalType (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<ExternalGeometryFacadePy*>(self)->setInternalType(Py::String(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'InternalType' of object 'ExternalGeometryFacade'");
        return -1;
    }
}

// Blocked() callback and implementer
// PyObject*  ExternalGeometryFacadePy::Blocked(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getBlocked (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<ExternalGeometryFacadePy*>(self)->getBlocked());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'Blocked' of object 'ExternalGeometryFacade'");
        return nullptr;
    }
}

int ExternalGeometryFacadePy::staticCallback_setBlocked (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<ExternalGeometryFacadePy*>(self)->setBlocked(Py::Boolean(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'Blocked' of object 'ExternalGeometryFacade'");
        return -1;
    }
}

// Tag() callback and implementer
// PyObject*  ExternalGeometryFacadePy::Tag(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getTag (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<ExternalGeometryFacadePy*>(self)->getTag());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'Tag' of object 'ExternalGeometryFacade'");
        return nullptr;
    }
}

int ExternalGeometryFacadePy::staticCallback_setTag (PyObject *self, PyObject * /*value*/, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }

    PyErr_SetString(PyExc_AttributeError, "Attribute 'Tag' of object 'ExternalGeometryFacade' is read-only");
    return -1;
}

// Geometry() callback and implementer
// PyObject*  ExternalGeometryFacadePy::Geometry(PyObject *args){};
// has to be implemented in ExternalGeometryFacadePyImp.cpp
PyObject * ExternalGeometryFacadePy::staticCallback_getGeometry (PyObject *self, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    try {
        return Py::new_reference_to(static_cast<ExternalGeometryFacadePy*>(self)->getGeometry());
    } catch (const Py::Exception&) {
        // The exception text is already set
        return nullptr;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while reading attribute 'Geometry' of object 'ExternalGeometryFacade'");
        return nullptr;
    }
}

int ExternalGeometryFacadePy::staticCallback_setGeometry (PyObject *self, PyObject *value, void * /*closure*/)
{
    if (!static_cast<PyObjectBase*>(self)->isValid()){
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return -1;
    }
    if (static_cast<PyObjectBase*>(self)->isConst()){
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a method");
        return -1;
    }

    try {
        static_cast<ExternalGeometryFacadePy*>(self)->setGeometry(Py::Object(value,false));
        return 0;
    } catch (const Py::Exception&) {
        // The exception text is already set
        return -1;
    } catch (...) {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown exception while writing attribute 'Geometry' of object 'ExternalGeometryFacade'");
        return -1;
    }
}




//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------
ExternalGeometryFacadePy::ExternalGeometryFacadePy(ExternalGeometryFacade *pcObject, PyTypeObject *T)
    : BaseClassPy(static_cast<BaseClassPy::PointerType>(pcObject), T)
{
}


//--------------------------------------------------------------------------
// destructor
//--------------------------------------------------------------------------
ExternalGeometryFacadePy::~ExternalGeometryFacadePy()                                // Everything handled in parent
{
}

//--------------------------------------------------------------------------
// ExternalGeometryFacadePy representation
//--------------------------------------------------------------------------
PyObject *ExternalGeometryFacadePy::_repr()
{
    return Py_BuildValue("s", representation().c_str());
}

//--------------------------------------------------------------------------
// ExternalGeometryFacadePy Attributes
//--------------------------------------------------------------------------
PyObject *ExternalGeometryFacadePy::_getattr(const char *attr)			// __getattr__ function: note only need to handle new state
{
    try {
        // getter method for special Attributes (e.g. dynamic ones)
        PyObject *r = getCustomAttributes(attr);
        if(r) return r;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError,"Unknown C++ exception");
        return nullptr;
    }
#endif

    PyMethodDef *ml = Methods;
    for (; ml->ml_name != nullptr; ml++) {
        if (attr[0] == ml->ml_name[0] &&
            strcmp(attr+1, ml->ml_name+1) == 0)
            return PyCFunction_New(ml, this);
    }

    PyErr_Clear();
    return BaseClassPy::_getattr(attr);
}

int ExternalGeometryFacadePy::_setattr(const char *attr, PyObject *value) // __setattr__ function: note only need to handle new state
{
    try {
        // setter for special Attributes (e.g. dynamic ones)
        int r = setCustomAttributes(attr, value);
        // r = 1: handled
        // r = -1: error
        // r = 0: ignore
        if (r == 1)
            return 0;
        else if (r == -1)
            return -1;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return -1;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return -1;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return -1;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return -1;
    }
#endif

    return BaseClassPy::_setattr(attr, value);
}

ExternalGeometryFacade *ExternalGeometryFacadePy::getExternalGeometryFacadePtr() const
{
    return static_cast<ExternalGeometryFacade *>(_pcTwinPointer);
}

#if defined(__clang__)
# pragma clang diagnostic pop
#endif

#if 0
/* From here on come the methods you have to implement, but NOT in this module. Implement in ExternalGeometryFacadePyImp.cpp! This prototypes
 * are just for convenience when you add a new method.
 */

PyObject *ExternalGeometryFacadePy::PyMake(PyTypeObject* /*type*/, PyObject* /*args*/, PyObject* /*kwds*/)
{
    // create a new instance of ExternalGeometryFacadePy and the Twin object
    return new ExternalGeometryFacadePy(new ExternalGeometryFacade);
}

// constructor method
int ExternalGeometryFacadePy::PyInit(PyObject* /*args*/, PyObject* /*kwd*/)
{
    return 0;
}


// returns a string which represents the object e.g. when printed in python
std::string ExternalGeometryFacadePy::representation() const
{
    return {"<ExternalGeometryFacade object>"};
}

PyObject* ExternalGeometryFacadePy::testFlag(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::setFlag(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::mirror(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::rotate(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::scale(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::transform(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::translate(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::hasExtensionOfType(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::hasExtensionOfName(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::getExtensionOfType(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::getExtensionOfName(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::setExtension(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::deleteExtensionOfType(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::deleteExtensionOfName(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* ExternalGeometryFacadePy::getExtensions(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}



Py::String ExternalGeometryFacadePy::getRef() const
{
    //return Py::String();
    throw Py::AttributeError("Not yet implemented");
}

void  ExternalGeometryFacadePy::setRef(Py::String arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Long ExternalGeometryFacadePy::getId() const
{
    //return Py::Long();
    throw Py::AttributeError("Not yet implemented");
}

void  ExternalGeometryFacadePy::setId(Py::Long arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean ExternalGeometryFacadePy::getConstruction() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  ExternalGeometryFacadePy::setConstruction(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Long ExternalGeometryFacadePy::getGeometryLayerId() const
{
    //return Py::Long();
    throw Py::AttributeError("Not yet implemented");
}

void  ExternalGeometryFacadePy::setGeometryLayerId(Py::Long arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::String ExternalGeometryFacadePy::getInternalType() const
{
    //return Py::String();
    throw Py::AttributeError("Not yet implemented");
}

void  ExternalGeometryFacadePy::setInternalType(Py::String arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::Boolean ExternalGeometryFacadePy::getBlocked() const
{
    //return Py::Boolean();
    throw Py::AttributeError("Not yet implemented");
}

void  ExternalGeometryFacadePy::setBlocked(Py::Boolean arg)
{
    throw Py::AttributeError("Not yet implemented");
}

Py::String ExternalGeometryFacadePy::getTag() const
{
    //return Py::String();
    throw Py::AttributeError("Not yet implemented");
}

Py::Object ExternalGeometryFacadePy::getGeometry() const
{
    //return Py::Object();
    throw Py::AttributeError("Not yet implemented");
}

void  ExternalGeometryFacadePy::setGeometry(Py::Object arg)
{
    throw Py::AttributeError("Not yet implemented");
}

PyObject *ExternalGeometryFacadePy::getCustomAttributes(const char* /*attr*/) const
{
    return nullptr;
}

int ExternalGeometryFacadePy::setCustomAttributes(const char* /*attr*/, PyObject* /*obj*/)
{
    return 0;
}


#endif



